import sys
from Bio import SeqIO
import csv

def main():
    input_fasta, output_file = sys.argv[1:]

    with open(input_fasta, 'r') as input_file, \
         open(output_file, 'w') as output_file:
        csv_writer = csv.writer(output_file)
        for record in SeqIO.parse(input_file, "fasta"):
            csv_writer.writerow([record.description, len(record)])

if __name__ == "__main__":
    main()
